(***********************************************************************)
(*                                                                     *)
(*                       Ambients in JoCaml                            *)
(*                                                                     *)
(*               Alan Schmitt, projet Para, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 1999 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

type process =
    Par of process * process
  | Seq of capacity * process
  | Amb of name * process * bool
  | New of string * process
  | Comm_in of string * process
  | Comm_out of capacity
  | Bang of process
  | Zero
      
and capacity =
    In of name
  | Out of name
  | Open of name
  | Name of name
  | Yell of string
  | Seq_capa of capacity * capacity	

and name =
    Ident of string
  | ResolvedName of string
