(***********************************************************************)
(** Module de CONVERSION d'un fichier .ppm (RAW) en color array array **)
(*                                                                     *)
(*---------------------------------------------------------------------*)
(*                                                                     *)
(* getint <in_channel> -> int                                          *)
(*        sert de parser du fichier ascii                              *)
(* convert <string> -> <color array array>                             *)
(* convert2 <string * color> -> <color array array>                    *)
(* get_tcolor < int * int * int * int * color array array>             *)
(*                   -> <color array array>                            *)
(***********************************************************************)      



let rec getint f = 
  try
    let c = input_char f in
    match c with
      'P' | '#' -> input_line f;
        getint f
    | ' ' | '\n'-> getint f
    | _ -> let a = String.make 3 ' ' in 
      a.[0] <- c;
      let c2 = input_char f in
      match c2 with
        ' ' | '\n' -> a.[2] <- a.[0];
          a.[0] <- '0';
          a.[1] <- '0';
          int_of_string a
      | _ -> a.[1] <- c2;
          let c3 = input_char f in
          match c3 with
            ' ' | '\n' ->
              a.[2] <- a.[1];
              a.[1] <- a.[0];
              a.[0] <- '0';
              int_of_string a
          | _ -> a.[2] <- c3; 
              int_of_string a

  with
  | End_of_file -> close_in f;
      
      Pervasives.exit 0;;

(* conversion sans transparence *)
let convert fichier =
  let f=open_in fichier in
  let d  = getint f 
  and  e = getint f 
  and  g = getint f in
  let image = create_matrix e d (rgb 0 0 0) in 
  let c0 = input_byte f in
  for j = 0 to (e-1) do
    for i = 0 to (d-1) do
      let c1 = input_byte f
      and c2 = input_byte f
      and c3 = input_byte f in
      image.(j).(i) <- rgb c1 c2 c3;
    done
  done;
  close_in f;
  image;;



(* conversion avec transparence *)
let convert2 fichier =
  let f=open_in fichier in
  let d  = getint f 
  and  e = getint f 
  and  g = getint f in
  let image = create_matrix e d (rgb 0 0 0) in 
  let c0 = input_byte f in
  for j = 0 to (e-1) do
    for i = 0 to (d-1) do
      let c1 = input_byte f
      and c2 = input_byte f
      and c3 = input_byte f in
      let col = rgb c1 c2 c3 in
      if col = (rgb 255 255 255) then image.(j).(i) <- transp
      else
        image.(j).(i) <- col;
    done
  done;
  close_in f;
  image
    ;;


let get_tcolor y x dy dx source=
  let arendre = create_matrix dx dy white
  in
  begin
    for ix = 0 to (dx-1) do
      for jy = 0 to (dy-1) do
        arendre.(ix).(jy) <- source.(x+ix).(y+jy)
      done
    done;
    arendre
  end;;


let changecol source col1 col2=
  let x = Array.length source 
  and y = Array.length source.(0)
  in
  for ix = 0 to (x-1) do
    for iy = 0 to (y-1) do
      if source.(ix).(iy) = col1 then source.(ix).(iy) <- col2
    done
  done;;
