(***********************************************************************)
(*                                                                     *)
(*                     the Jocaml language: examples                   *)
(*                                                                     *)
(*       Fabrice Le Fessant, projet PARA, INRIA Rocquencourt           *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

open Unix
open ThreadUnix

let ns_name = ref "newclient"
let ns_host = Ns.name
let ns_port = Ns.port

let rec start_creation first second third i =
  if i>0 then
    begin
      Printf.printf "Creating new cycle %d" i; print_newline () ;
      let loc a 
          def link_a! t = if t then { link_a t | link_b t | link_c t | link_d t}
        do { Join.go first; link_a false }
          and b
            def link_b! t = if t then { link_a t | link_b t | link_c t | link_d t}
        do { Join.go second; link_b false }
            and c
              def link_c! t = if t then { link_a t | link_b t | link_c t | link_d t}
        do { Join.go third; link_c false }
              and d 
                def link_d! t = if t then { link_a t | link_b t | link_c t | link_d t}
        do { }
      in
      start_creation first second third (i-1)
    end
    

let def register_me (location,(name:string),(args:string list)) | locations! list =
    {  
      match list with
        [first; second] -> {
            let third = location in
            let loc gc_first do
                { Join.go first; while true do sleep 1; Gc.major (); done;}
              and  gc_second do
                { Join.go second; while true do sleep 1; Gc.major (); done;}  
              and  gc_third do
                { Join.go third; while true do sleep 1; Gc.major (); done;}  
              and  gc_server do
                { while true do sleep 1; Gc.major (); done;} in
            let loc job def kill! () = Join.halt (); 
              do {
                  sleep 5;
                  start_creation first second third 1;
(*                  sleep 20;
                  Dgc.set_debug_flag true; *)
                  } 
            in
            { Join.fail(first); kill () } | { Join.fail(second); kill () }}
      | list -> locations (location :: list)     
    } | reply () 
      
let _ = 
  Join.spawn_send locations [];
  Ns.register !ns_name register_me vartype;
  Join.server ()
