(***********************************************************************)
(*                                                                     *)
(*                           xlib for Ocaml                            *)
(*                                                                     *)
(*       Fabrice Le Fessant, projet Para/SOR, INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* dessiner un echiquier *)

open Xtypes
open Xlib
open X
open Xutils

(* quelques valeurs utiles *)
let dpy = openDisplay(Sys.getenv "DISPLAY");;
let black= defaultBlack dpy;;
let white= defaultWhite dpy;;
let fixed= openFont dpy "fixed";;
let root = defaultRoot dpy;;

(* un rectangle *)
let r= newRect 10 10 500 500

(* la fenetre principale *)
let win= createWindow dpy root 10 10 500 500 0 InputOutput 0 1 [CWBackPixel white]

let _ = 
  selectInput dpy win [KeyPressMask];
  mapWindow dpy win

(* on cree les sous-fenetres *)
let width = 50
let subwindow x y couleur=
  let w = createWindow dpy win (x*width) (y*width) width width 0
      InputOutput 0 1 [CWBackPixel couleur]
  in
  mapWindow dpy w
    

let defcolor=defaultColormap dpy;;
let { anc_pixel = red } = allocNamedColor dpy defcolor "red";;
let { anc_pixel = green } = allocNamedColor dpy defcolor "green";;

for i=0 to 7 do
  for j=0 to 7 do
       subwindow i j (if( (i+j) mod 2)=0 then red else green)
    done
  done
;;

let _ =
  while true do
    let ev = Xlib.nextEvent dpy in
    match ev.ev_event with
      KeyPressEvent k when ev.ev_window == win -> exit 0
    | _ -> ()
  done



