(***********************************************************************)
(*                                                                     *)
(*                           xlib for Ocaml                            *)
(*                                                                     *)
(*       Fabrice Le Fessant, projet Para/SOR, INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

open Xlib;;
open Xutils;;
open Icccm;;
open Xtypes


let dpy = Xlib.openDisplay (Sys.getenv "DISPLAY");;

let root = defaultRoot dpy;;
let cursor = createFontCursor dpy XC.xc_crosshair;;

let w = selectWindow dpy cursor;;
let win = clientWindow dpy w;;

print_string (getWM_NAME dpy win); print_newline ();;
setWM_NAME dpy win "Shell2";;
print_string (getWM_NAME dpy win); print_newline ();;
setWM_NAME dpy win "Bonjour a tous";;



let prop =
  try
    getWholeProperty dpy win XA.xa_wm_hints
  with
      Not_found -> failwith "XW_HINTS not found";;

getWM_SIZE_HINTS dpy win XA.xa_wm_normal_hints;;
let h = newWM_SIZE_HINTS ();;
h.min_size <- Some (100,100);;
h.max_size <- Some (1000,1000);;
setWM_SIZE_HINTS dpy win XA.xa_wm_normal_hints h;;

let h= getWM_HINTS dpy win XA.xa_wm_hints;;
h.icon_position <- Some (900,900);;
setWM_HINTS dpy win h;;

getStringListProperty dpy win XA.xa_wm_class;;
setStringListProperty dpy win XA.xa_wm_class ["NXTerm1"; "nxterm1"];;

