open Select
  
let offers = ref []
  
let def register_me (local, name, args) =
    reply |
      { let name = match args with
          | [name] -> name
          | _ -> ":0"
        in
        offers := (name, local) :: !offers; }

let restart location dpyname = 
  let display = Xterm.create_display !displayname 
      location.loc_colors_names location.loc_fonts_names "Efuns" "efuns"
  in
  display.Xterm.dpy_highlighted <- 2;
  
  List.iter (fun top ->
      let xterm = Xterm.create_window 
        display "new_frame"
          location.loc_font 
          top.top_width
          top.top_height in
      top.top_display <- Some  display;
      top.top_xterm <- Some xterm;
      Xterm.install_handler display xterm 
      (Top_window.handler top xterm);      
      ) location.loc_windows;
  
  Top_window.update_display location; 
  (* Main loop *)
  let rec loop () =
    try
      Xterm.event_loop ()
    with
      SigInt -> loop ()
  in
  loop ()

  
 
let migrate frame =
  simple_select frame "Go to display :"
    (fun dpyname ->
      let destination = List.assoc dpyname !offers in
      (* clean up all dependencies towards X components *)
      let location = frame.frm_location in
      List.iter (fun top ->
          top.top_display <- None;
          top.top_xterm <- None;
      ) location.loc_windows;
      let def wait! () | waiting () = reply | { exit 0; } in
      let loc agent 
          [Migrate]
        do { go destination;
            restart location dpyname; wait () }
      in
      waiting ()
  )
      
let _ = (* register our service in the name server *)
  Ns.new_server !ns_host !ns_port;
  Ns.register !ns_name register_me vartype

