(***********************************************************************)
(*                                                                     *)
(*                           xlib for Ocaml                            *)
(*                                                                     *)
(*       Fabrice Le Fessant, projet Para/SOR, INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)


                    open Xtypes
open Display

val getStringProperty : display -> window -> atom -> string
val getWM_NAME : display -> window -> string
val getWM_ICON_NAME : display -> window -> string
val getWM_CLIENT_MACHINE : display -> window -> string
val setStringProperty :
  display -> window -> atom -> string -> unit
val setWM_NAME : display -> window -> string -> unit
val setWM_ICON_NAME : display -> window -> string -> unit
val setWM_CLIENT_MACHINE :
  display -> window -> string -> unit
val getStringListProperty :
  display -> window -> atom -> string list
val getWM_CLASS : display -> window -> string
val getWM_COMMAND : display -> window -> string
val setStringListProperty :
  display -> window -> atom -> string list -> unit
val setWM_CLASS : display -> window -> string list -> unit
val setWM_COMMAND : display -> window -> string list -> unit
val getWM_SIZE_HINTS :
  display -> window -> atom -> wm_size_hints
val setWM_SIZE_HINTS :
  display -> window -> atom -> wm_size_hints -> unit
val newWM_SIZE_HINTS : unit -> wm_size_hints
val setWM_NORMAL_HINTS : display -> window -> wm_size_hints -> unit
val getWM_HINTS : display -> window -> atom -> wm_hints
val setWM_HINTS : display -> window -> wm_hints -> unit
val newWM_HINTS : unit -> wm_hints
val getCard32Property :
  display -> window -> atom -> atom -> int list
val getWM_TRANSIENT_FOR : display -> window -> int
val getWM_PROTOCOLS : display -> window -> int list
val getWM_COLORMAP_WINDOWS : display -> window -> int list
val setCard32Property :
  display -> window -> atom -> atom -> int list -> unit
val setWM_TRANSIENT_FOR : display -> window -> window -> unit
val setWM_PROTOCOLS : display -> window -> int list -> unit
val setWM_COLORMAP_WINDOWS : display -> window -> int list -> unit
val getWM_STATE : display -> window -> wmState * window
val setWM_STATE : display -> window -> wmState * window -> unit
val setWM_ICON_SIZE :
  display -> window -> wm_icon_size list -> unit
val getWM_ICON_SIZE : display -> window -> wm_icon_size list
val withdrawWindow : display -> window -> window -> unit
val iconifyWindow : display -> window -> window -> unit
