(***********************************************************************)
(*                                                                     *)
(*                             Xlib                                    *)
(*                                                                     *)
(*       Fabrice Le Fessant, projets Para/SOR, INRIA Rocquencourt      *)
(*                                                                     *)
(*  Copyright 1999 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(*
  Ressources management. Quite simplified.
*)

type t

(* create a new database *)
val create: unit -> t

(* [load]: load a file into the database, 
   [save]: save the database in a file *)
val load: t -> string -> unit
val save: t -> string -> unit

(* [get]: look for a resource from the database, 
   [set]: modify a ressource *)
val get: t -> string list -> string
val set: t -> string list -> string -> unit
