(***********************************************************************)
(*                                                                     *)
(*                           xlib for Ocaml                            *)
(*                                                                     *)
(*       Fabrice Le Fessant, projet Para/SOR, INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)


open Xtypes
open Display

val defaultRoot : display -> window
val defaultWhite : display -> pixel
val defaultBlack : display -> pixel
val defaultDepth : display -> int
val defaultColormap : display -> colormap
val defaultOpenDisplay :
  string -> display * window * pixel * pixel
val selectInput : display -> window -> eventMask list ->  unit Jeton.t
val clientWindow : display -> window -> window
val clearWindow : display -> window -> unit
val drawString :
  display ->
  window -> gc -> coord -> coord -> string -> int -> int -> unit
type rect =
  { mutable x: int;
    mutable y: int;
    mutable dx: int;
    mutable dy: int }
val newRect : int -> int -> int -> int -> rect
val createFontCursor : display -> int -> cursor
val selectWindow : display -> cursor -> window
val getWholeProperty :
  display ->
  window -> atom ->Xtypes.getPropertyRep
val listProperties :
  display -> window -> (string * string * int * int * string) list
val xapply : cursor -> display -> (window -> 'a) -> 'a
val xprop :
  cursor -> display -> (string * string * int * int * string) list
val sync : display -> xerror
val textExtents : queryFontRep -> string -> charInfo
val textWidth : queryFontRep -> string -> int
(*
val peekEventSuch : display -> (bigEvent -> bool) -> bigEvent
val peekIfEvent : display -> (bigEvent -> bool) -> bigEvent
val checkIfEvent : display -> (bigEvent -> bool) -> bigEvent
val ifEvent : display -> (bigEvent -> bool) -> bigEvent
val putBackEvent: display -> bigEvent -> unit
*)
val raiseWindow : display -> window -> unit
val lowerWindow : display -> window -> unit
