open Unix
open Graphics
open ThreadUnix
open Thread

(*external sys_exit : int -> 'a = "sys_exit"*)

(*let server = Nfs.query "JoCaml-server";;
let (play: Join.location => unit) =
                  Join.getRemoteService server "play" vartype;;
*)
let loc me = struct  end;;
let remote_proc = ref "";;

let read_token fd =
  let rec read_rec buf bufsize offs =
    let n = read fd buf offs 1 in
      if n = 0 then raise End_of_file
      else if List.mem buf.[offs] ['\n'; ' '; '\t']
           then String.sub buf 0 offs
	   else let offs = succ offs in
	      if offs = bufsize 
      	      then read_rec (buf ^ String.create 32) (bufsize + 32) offs
	      else read_rec buf bufsize offs in
  read_rec (String.create 32) 32 0 

let read_int fd =
  int_of_string (read_token fd)

let read_string fd =
  let len = read_int fd in
  let s = String.create len in
    read fd s 0 len;
    s

let read_ack fd =
  read fd " " 0 1;
  ()

let write_int fd n =
  let s = string_of_int n ^ " " in
    write fd s 0 (String.length s);
    ()

let write_string fd s =
  write_int fd (String.length s);
  write fd s 0 (String.length s);
  ()

let write_ack fd =
  write fd " " 0 1;
  ()
;;

let wait_key() =
try
while true do 
if key_pressed() then if read_key() = 'a' then raise End_of_file done
with
| End_of_file -> ()
;; 

let nwino = ref 0;;
let newinst = ref false;;

let main()=

  let pid = ref 0 in
   Arg.parse [
      "-pid", Arg.Int (fun i -> pid := i), "Netscape pid"
     ]
   (fun s -> ())
   "Usage: calves <options>";

  Sys.catch_break true;  (* Avoid SIGPIPE completely, in favor of write() errors *)
  Sys.signal Sys.sigpipe Sys.Signal_ignore;


 (* synchro : we create the socket, and then fork() to that the parent
     returns, and the child does the work. 
     Our caller can invoke system("calves") and be sure that when the
     call returns, the socket accepts connections
   *)

 let s = socket PF_UNIX SOCK_STREAM 0 in
     setsockopt s SO_REUSEADDR true;
     (* we might have several NN running *)
     let sockname = 
       Filename.concat (Filename.concat (Sys.getenv "HOME") ".netscape")
                       (Printf.sprintf "Joplug-%08d" !pid) in

     (* This creates the socket *)
     Unix.bind s (ADDR_UNIX sockname);
     listen s 10;

  match fork() with
    0 -> (* the child *)

    let fd, sock_addr = accept s in
  
while true do
match select [fd] [] [] 0.5 with
[],[],[] -> (* delai depasse, on yield*)
  delay 0.0;
| fdl,[],[] ->
 
    match read_string fd with
       "INIT" -> (* the master connection *)
	 while true do
	 match select [fd] [] [] 0.5 with
	   [],[],[] -> (* delai depasse, on yield*)
	     delay 0.0;
	 | fdll,[],[] ->
	     match read_string fd with
	       "NEW" ->
		 let argc = read_int fd in
		 let args = ref [] in
		 for i = 0 to argc - 1 do
		   let name = read_string fd in
		   let value = read_string fd in
		   args := (name, value) :: !args
		 done;
		 let argm = List.map (function (name,value) -> String.lowercase name, value) !args in
		 let port= int_of_string (List.assoc "jnsport" argm) in
		 let mname = (List.assoc "jnsname" argm) in
		 Ns.new_server mname port;
		 remote_proc := (List.assoc "remotep" argm);
      	         newinst := true;
	     | "WIN" ->
		 let wx=read_int fd in
		 let wy=read_int fd in
		 let ww=read_int fd in
		 let wh=read_int fd in
		 let param = " "^(string_of_int ww)^"x"^(string_of_int wh)^"+"^(string_of_int wx)^"+"^(string_of_int wy) in
		 if !newinst then begin
		   newinst := false;
		   open_graph2 param; (*(" 560x380+30+30");*)
let (play: Join.location => unit) = Ns.lookup !remote_proc vartype in
		   play me;
		   end;

		 write_int fd (getwin());
	     | "KILL" ->
		 write_ack fd;
		 close fd;
		 close_graph();
		 Pervasives.exit 0;
	     | _ -> delay 0.0;
	  done
     | "CALLB" -> ()(* the fd for callbacks *)
     | "STREAM" ->()
     | _ -> ()
 done 

 | _ -> (* the parent *)
      Pervasives.exit 0;

in  main ();;








