(*
  on simule un parking de 'nplaces' places et de 'nentrees' entrees.

Chaque entree maintient un compteur 'offset avec le coordinateur'. Cette 
entree peut toujours etre positive (des voitures sont sorties), mais ne
peut etre negative que dans une limite acceptable.

Le parking travaille avec deux regimes:
- plein: on ne laisse entrer une voiture qu'avec le coordinator. on laisse
    sortir les voitures, mais on prend alors le coordinator.
- vide: on laisse entrer les voitures avec une certaine marge. La marge peut
    etre renegociee au besoin.

*)

(*
Deux etats: libre et controle'.
- Libre: chaque porte dispose d'un certain capital de places libres qu'elle 
gere toute seule.
- Controle': un jeton circule pour permettre l'entree des voiture. La sortie 
  des voitures est ge're'e localement.
  
Chaque porte possede un canal entrer et un canal sortir. Une voiture peut 
  entrer par une porte et sortir par une autre.
*)

def entrer() = requise () | { entrer2 (); reply to entrer}
and sortir () = sortir2 ()

def entrer() | libre!(n) = 
  { reply to entrer } |
    { if n=1 then vide () else libre(n-1) }
or sortir() | libre!(n) = 
    { reply to sortir } | libre(n+1)
or sortir() | vide!() =
    { reply to sortir } | libre(1)
or entrer() | vide!() =
    let n = get_places () in
    entrer () | libre(n)

and get_places () | jeton
    
