open Xdisp
open Buffer
open Functions

let open_display name =
  let old_display = open_display name in
  let def wait_go! () | gone () = reply in
  let loc display 
      def
      miniMessage! m = old_display.miniMessage m; reply
  and drawString! m = old_display.drawString m; reply
  and clearArea! m = old_display.clearArea m; reply
  and addBuffer! m = old_display.addBuffer m; reply
  and removeBuffer! m = old_display.removeBuffer m; reply
  and printStatus! m = old_display.printStatus m; reply
  and enableMini! m = old_display.enableMini m; reply
  and listBuffers! m = old_display.listBuffers m; reply 
  and closeDisplay! m = old_display.closeDisplay m; reply
  and eventLoop! m = {old_display.eventLoop m;} | reply
do { go top_location; gone () }
  in
  { miniMessage = miniMessage;
    drawString = drawString;
    clearArea = clearArea;
    removeBuffer = removeBuffer;
    printStatus = printStatus;
    enableMini = enableMini;
    listBuffers = listBuffers;
    closeDisplay = closeDisplay;
    eventLoop = eventLoop;
    addBuffer =
    (fun buffer_obj ->
      let def expose! () = buffer_obj.expose (); reply
      and keypress! n = buffer_obj.keypress n; reply
      in
      addBuffer { expose = expose; keypress = keypress });
  } 

let _ =
  let display = open_display ":0" in
  let location_info = {
    display = display;
    global_map = unbound_map ();
  } in
  Join.server ();
  init_map location_info;
  let loc mobile [Xdebug; Xfifo; Jeton; Xtypes; Xconst; Xbuffer; Xauth; 
                   Ll_trans; Conv_event; Display; Xproto; X; XK; KeyBind; 
                   Xlib; Xutils; Buffer;  Xdisp; Xterm; Concur]


      def 
      migrate! (dest, name) = 
    { 
    let old_display = location_info.display in
    let buffers = old_display.listBuffers () in
    location_info.display <- dummy_display;
    go dest;
    print_string "1"; print_newline ();
    let display = open_display name in
    print_string "2"; print_newline ();
    old_display.closeDisplay ();
    print_string "3"; print_newline ();
    location_info.display <- display;
    List.fold_right (fun buf () -> 
      print_string "4"; print_newline ();
      display.addBuffer buf;
      print_string "5"; print_newline ();
      ) buffers ();
    print_string "6"; print_newline ();
    display.eventLoop ();
    print_string "7"; print_newline ();
    Genserver.server register_me vartype;
    reply
  } 
  and register_me! (local,name,(args : string list)) =
    migrate (local, name ^ ":0"); reply

do {
    new_buffer location_info "*scratch*" "" 0 0 80 25;
    display.eventLoop ();
} 
in
  Genserver.server register_me vartype
