let cadmiumFlag = ref false
let char = 'z'

let printSpace () = 
(* prints the space_id of the current space *)
  if (!cadmiumFlag) then 
    begin
      let (((addr: Unix.inet_addr),(port: Jtypes.port)),(time:Jtypes.time)) = Space.local_id
      in 
      	Debug.print3 char "Space_id is ---> Addr: %s, Port: %s, Time:%s\n" 
	  (Unix.string_of_inet_addr addr)
	  (string_of_int port)
	  (string_of_float time);
    end

let printLocation (location) = 
(* prints the space_id of the given location *)
  if (!cadmiumFlag) then 
    begin
      let (_,_,space,_,_,_) = Jcompat.get_stub_info location  (* int * (locator option) * space * location * bool * gc_stub *)
      in
      let (((addr: Unix.inet_addr),(port: Jtypes.port)),(time:Jtypes.time)) = space.Jtypes.space_id
      in
      	Debug.print3 char "Space_id is ---> Addr: %s, Port: %s, Time:%s\n" 
	  (Unix.string_of_inet_addr addr)
	  (string_of_int port)
	  (string_of_float time);	
    end

(*       	Debug.print1 char "%s\n" (Space.string_of_space_id space.Jtypes.space_id); *)

let printnl str =
(* prints any string and a newline *)
  if (!cadmiumFlag) then
    begin
      Debug.print1 char "Cadmium: %s\n" str;
    end

let print str =
(* prints any string *)
  if (!cadmiumFlag) then
    begin
      Debug.print1 char "Cadmium: %s" str;
    end

let newline () =
(* prints a newline, presentation purpose*)
  if (!cadmiumFlag) then
    begin
      Debug.print0 char "\n";
    end
