open Jtypes

(* Attention :                                                                      *)
(* verifier les Some et None dans les listes de stubs avant de les virer            *)
(* disconnectStub & disconnectScion => traiter cas ou la liste des espaces est vide *)
(* gerer les references vers d'autre espace sur la meme machine (i.e. pas de copie) *)
(* utilite du parametre de disconnect ? Pourra deconnecter un autre espace que      *)
(* l'espace courant ? Acces aux tables ?                                            *)
(* traiter le cas ou il n'y a pas d'espace cache dans DisconnectStub *)


let _ = CdDebug.cadmiumFlag := true
let char = 'z'


(* Disconnection management *)

let def disconnectStub! (space) = (* synchronous channel to get objects referenced *)
                                  (* by the client space *)
{
  Debug.print0 char "disconnectStub\n";
  let Some (Cache cache) = space.Jtypes.cdCache  (* *** attention si pas de cache ! *)
  in
    Space.send cache
      (let send = Jmarshal.marshal cache 
		    (DisconnectStub (!(CdUtils.list_all_object_stubs !(CdUtils.list_spaces ())))) 
       in Debug.print0 char "Send DisconnectStub to the cache\n"; send);  
    Debug.print0 char "disconnectStub: client uids are:\n";
    CdUtils.print_uids (!(CdUtils.list_all_object_stubs !(CdUtils.list_spaces ())));
    reply ()
}

let def disconnectScion () = (* asynchronous channel to get objects of the client space *)
                             (* referenced from the outside *)
{
  Debug.print0 char "disconnectScion - to do\n";
}

let disconnect space = (* global disconnection, called by the client space *)
  Debug.print1 char "Disconnect space %s: started\n" (Space.string_of_space_id space.space_id);
  disconnectScion;
  disconnectStub (space);
  Debug.print1 char "Disconnect space %s: done\n" (Space.string_of_space_id space.space_id)
