(***********************************************************************)
(*                                                                     *)
(*                    Join : fail.ml                                   *)
(*                                                                     *)
(*      Fabrice Le Fessant, projet SOR/PARA INRIA Rocquencourt         *)
(*                                                                     *)
(*                 mail: fabrice.le_fessant@inria.fr                   *)
(*                 web:  http://www-sor.inria.fr/~lefessan             *)
(*                                                                     *)
(*  Copyright 1997 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(*

 - Les failures:

Principale caractristique: on est en mode connect, on peut rompre
des liaisons dune faon dfinitive entre deux points.

Le problme, cest que les liaisons entre locations ne correspondent
pas directement aux liaisons entre espaces.

On distingue les locations des espaces, et on ne teste que les pannes
despaces.

1. Pannes simples:
-  Rupture de liaison avec un espace: suffisant pour detecter des pertes 
possibles de messages. Se declenche uniquement quand ltat passe de connect 
dconnect.
-  Terminaison dune location principale: sure par lenvoi dun message.
Nanmoins, il faut propager  tous les espaces connects la terminaison
de toutes les locations prsentes.

  *)

type t =
    LinkFailure
  | Halted
  | Timeout of float

let fail t space =
  match t with
    LinkFailure -> ()
  | Halted -> ()
  | Timeout dure -> ()
