open Unix
open ThreadUnix

let host = gethostname()

let args = ref []
let direct = ref false
let ns_user = Ns.user
let ns_host = Ns.name
let ns_port = Ns.port
let ns_name = ref "newclient"

let _ = Arg.parse
    [
  "-direct", Arg.Unit (fun () -> direct := true), ":connect directly instead of the name server";
  "-ns_host", Arg.String (fun s -> ns_host := s), ("<server>: connect to <server> default: "^ !ns_host);
  "-ns_user", Arg.String (fun s -> ns_user := s), "<name>: send name as user";
  "-ns_port", Arg.Int (fun i -> ns_port := i), ("<port>: connect to <port> default: "^ (string_of_int !ns_port));
  "-ns_name", Arg.String (fun s -> ns_name := s), ("<name>: query <name> default: "^ !ns_name);
]
    (fun s -> args := s :: !args) 
    "Args are passed during the call to the server"

let newclient =
    if !direct then
      let space = Join.space_of_string !ns_host !ns_port in
      Join.getRemoteService space !ns_name vartype
    else
      begin
        Ns.lookup !ns_name vartype
      end

let () = newclient (Join.here, !ns_user, !args)
let _ = Join.server ()
  
