open Unix
open ThreadUnix

let ns_name = ref "newclient"
let ns_host = Ns.name
let ns_port = Ns.port
let ns_user = Ns.user

let ns_args () = [
  "-ns_host", Arg.String (fun s -> ns_host := s), ("<host>: host hosting the name server default: "^ !ns_host);
  "-ns_port", Arg.Int (fun i -> ns_port := i), ("<port>: connect to <port> default: "^ (string_of_int !ns_port));
    "-ns_name", Arg.String (fun s -> ns_name := s), ("<name>: query <name> default: "^ !ns_name);
  "-ns_user", Arg.String (fun s -> ns_user := s), "<name>: send name as user";
]

let server register_me vtype = 
  Ns.register !ns_name register_me vtype;
  Join.server ();

