/***********************************************************************/
/*                                                                     */
/*                           Join-Calculus                             */
/*                                                                     */
/*            Fabrice Le Fessant, projet PARA, INRIA Rocquencourt      */
/*                                                                     */
/*  Copyright 1998 Institut National de Recherche en Informatique et   */
/*  Automatique.  Distributed only by permission.                      */
/*                                                                     */
/***********************************************************************/

#include "callback.h"
#include "config.h"
#include "misc.h"
#include "mlvalues.h"
#include "stacks.h"
#include "fail.h"
#include "io.h"
#include "roots.h"
#include "alloc.h"
#include "memory.h"
#include "signals.h"
#include "gc_ctrl.h"
#include "intext.h"
#include "weak.h"
#include "gc.h"

#include "join.h"


value breakpoint(value num,value v)/* ML */
{
  return Val_unit;
}

#include <stdio.h>
value prerr_string(value string)
{
  fprintf(stderr,"%s",String_val(string));
  return Val_unit;
}

value join_sys_exit(value exn_bucket)
{
  fprintf(stderr,"Exited in send_exception (UNRECOVERABLE): \n");
  fatal_uncaught_exception(exn_bucket);
  exit(2);
  return Val_unit;
}

 

/* camlrun/modules.c */
extern int module_cache_miss, module_cache_success;
extern int prims_miss, prims_success, modules_miss, modules_success;

/* threads/join/threads.c */
extern int reused_threads;

value print_stats(value unit)
{
  fprintf(stderr,"Modules:\n");
  fprintf(stderr,"modules miss: %d\n",modules_miss);
  fprintf(stderr,"modules success: %d\n",modules_success);
  fprintf(stderr,"primitives miss: %d\n",prims_miss);
  fprintf(stderr,"primitives success: %d\n",prims_success);
  fprintf(stderr,"cache miss: %d\n",module_cache_miss);
  fprintf(stderr,"cache success: %d\n",module_cache_success);
  fprintf(stderr,"Allocations:\n");
  fprintf(stderr,"Threads not allocated: %d\n",threads_reused);
  fprintf(stderr,"Threads allocated: %d\n",threads_allocated);
  fprintf(stderr,"Stacks not allocated: %d\n",stacks_reused);
  fprintf(stderr,"Stacks allocated: %d\n",stacks_allocated);
  /*
  fprintf(stderr,"Thread stub not allocated: %d\n",stub_reused);
  fprintf(stderr,"Thread stub allocated: %d\n",stub_allocated);
  */
  fprintf(stderr,"Dirty threads: %d\n", dirty_threads);
  fprintf(stderr,"Scheduler:\n");
  fprintf(stderr,"scheduler miss : %d\n",scheduler_miss);
  fprintf(stderr,"scheduler success : %d\n",scheduler_success);
  fprintf(stderr,"threads reused: %d\n", reused_threads);
  
  return Val_unit;
}
