(***********************************************************************)
(*                                                                     *)
(*                            JoCaml                                   *)
(*                                                                     *)
(*     Fabrice Le Fessant, projet Moscova/SOR, INRIA Rocquencourt      *)
(*                                                                     *)
(*  Copyright 2000 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

open Unix
open ThreadUnix

type request =
  Register of string * Jtypes.space_id
| Lookup of string 
  

let localname = Unix.gethostname ()
let first_addr entry = entry.h_addr_list.(0)

let port = 20001
let port_env = "JNSPORT"  
let port = ref (try int_of_string (Sys.getenv port_env) with _ -> port)

let name = localname
let name_env = "JNSNAME"  
let name = ref (try Sys.getenv name_env with _ -> name)
  
let connection_header = "NsServer20000405"
let connection_header_len = String.length connection_header
  
let mgroup = 101
let mgroup_env = "JNSMGROUP"  
let mgroup = ref (try int_of_string (Sys.getenv mgroup_env) with _ -> mgroup)


let mport = 20002
let mport_env = "JNSMPORT"  
let mport = ref (try int_of_string (Sys.getenv mport_env) with _ -> mport)

    
let mquery = "JOCAML:NAME SERVER?"
let mquery_len = String.length mquery

let ignore v = ()
  
let use_multicast = ref (try ignore (Sys.getenv "NO_MULTICAST"); false
  with _ -> true)
