/***********************************************************************/
/*                                                                     */
/*                           Join-Calculus                             */
/*                                                                     */
/*            Fabrice Le Fessant, projet PARA, INRIA Rocquencourt      */
/*                                                                     */
/*  Copyright 1998 Institut National de Recherche en Informatique et   */
/*  Automatique.  Distributed only by permission.                      */
/*                                                                     */
/***********************************************************************/

#include "callback.h"
#include "config.h"
#include "misc.h"
#include "mlvalues.h"
#include "stacks.h"
#include "fail.h"
#include "io.h"
#include "roots.h"
#include "alloc.h"
#include "memory.h"
#include "signals.h"
#include "gc_ctrl.h"
#include "intext.h"
#include "weak.h"
#include "gc.h"

#include "join.h"

/*********

   module Objects

*********/

value obj_copy(value obj,value debut,value len) /* ML */
{
  value res,i;

  Begin_root(obj);
  res = alloc(0,len);
  End_roots();
  for(i=0;i<len;i++)
    Field(res,i) = Field(obj,debut+i);
  
  return res;
}


value create_object_stub(value space,
			 value ext_buckets,value obj_size) /* ML */
{
  value res;
  
  Begin_roots2(space,ext_buckets); /* (pos,class) */
  res = obj_block (Val_int(Object_tag), obj_size);
  Assign(Field(res,STUB_POSITION),space);
  Assign(Field(res,STUB_EXT_TMV), ext_buckets); /* TMV exterieure */
  End_roots(); /* (pos,class) */

  return res;
}

value set_replicat(value stub,value contenu) /* ML */
{
  value i;

  for(i=0;i<Wosize_val(contenu);i++)
    Assign(Field(stub,i+6),Field(contenu,i));
  
  return Val_unit;
}

value create_new_object(value space,value location,value size,
			value module_data) /*  ML  */
{
  return create_location(space,location,module_data, Int_val(size), 
			 Object_tag);
}
