open Printf

let flags = Array.create 256 false
let fd = ref 
    (try
      open_out (Sys.getenv "JLOGFILE")
    with
      Not_found -> stderr)

let set debug =
  if debug = "-" then
    for i = 0 to 255 do flags.(i) <- true done
  else
    for i = 0 to (String.length debug)-1 do
      flags.(Char.code debug.[i]) <-  true;
    done

let log file = fd := file

let debug = try Sys.getenv "JDEBUG"  with Not_found -> ""
let _ = set debug

let print0  c f =
  if flags.(Char.code c) then
    (fprintf !fd "%s" (sprintf f); flush !fd)
let print1  c f x =
  if flags.(Char.code c) then
    (fprintf !fd "%s" (sprintf f x); flush !fd)
let print2 c f x y =
  if flags.(Char.code c) then
    (fprintf !fd "%s" (sprintf f x y); flush !fd)
let print3 c f x y z =
  if flags.(Char.code c) then
    (fprintf !fd "%s" (sprintf f x y z); flush !fd)
let print4 c f x y z w =
  if flags.(Char.code c) then
    (fprintf !fd "%s" (sprintf f x y z w); flush !fd)
let f c g  = if flags.(Char.code c) then g ()

let trap c s g =
  if flags.(Char.code c) then
    try
      g ()
    with
      e ->
        fprintf !fd "Exception %s in %s" (Printexc.to_string e) s;
        flush !fd;
        raise e
  else
    g ()

let print s =  print1 'a' "%s\n" s

