open Mop


(**** Object copy ****)

let copy (o : < .. >) : 'a =
  let o = Obj.repr (o : 'a) in
  let s = Obj.size o in
  let r = Obj.new_block Tag.object s in
  for i = 0 to s - 1 do Obj.set_field r i (Obj.field o i) done;
  Obj.set_field r 0 (Obj.repr 0); (* no locator *)
  Obj.set_field r 2 r;
  Obj.obj r

let new_method = Mop.new_method

let set_initializer = Mop.set_initializer
let inheritance = Mop.inheritance
let get_method = Mop.get_method
let set_method = Mop.set_method
let get_method_label = Mop.get_method_label
let get_variable = Mop.get_variable
let hide_variable = Mop.hide_variable
let get_private_variable = Mop.get_private_variable
let get_class_info = Mop.get_class_info
(* Objects *)
let create_object = Mop.create_object
(* Parameters *)
let params = Mop.params


let create_class class_info public_methods creator class_init module_data =
  let class_info =
    Mop.create_class  class_info public_methods creator class_init module_data
  in
  class_info.table.ext_buckets <- class_info.table.buckets

